// MemoConduit.cpp : DLL AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "MemoConduit.h"

#include <condapi.h>
#include <synccommon.h>

#pragma comment(lib, "sync20.lib")
#include <syncmgr.h>
#include <fstream>
#include <string>


#ifdef _MANAGED
#pragma managed(push, off)
#endif

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}

#ifdef _MANAGED
#pragma managed(pop)
#endif

HANDLE hLangInstance;

// ́AGNX|[gꂽNX̃RXgN^łB
// NX`ɊւĂ MemoConduit.h QƂĂB
CSynchronizer::CSynchronizer()
{
	return;
}

/******************************************************************************
 *
 * Class:   CSynchronizer
 *
 * Method:  Perform()
 *
 * Description: This method is the entry point to the conduit synchronization. 
 *          It retrieves all records from Memo applitcation 
 *			and writes them down into "c:/MemoSync.txt".
 *
 * Parameter(s): None.
 *
 * Return Value(s): 0 - no error
 *                  <0 - error code.
 *
 * Revision History:
 *
 * Date         Name        Description
 * ----------------------------------------------------------
 *  11/29/2007	IRJB		initial revision
 *
 *****************************************************************************/
long CSynchronizer::Perform()
{
    long retval = 0;
	CONDHANDLE m_ConduitHandle;
	CONDHANDLE &m_ConduitHandleRef = m_ConduitHandle;
	HSByte dbHandle;
	HSByte &dbHandleRef = dbHandle;
	CRawRecordInfo rrInfo;

	char	memo[MemoMaxLength];
	

    // Register the conduit
    retval = SyncRegisterConduit(m_ConduitHandleRef);
	if(retval){
		return retval;
	}
	
	//Open database on handheld.
	retval = SyncOpenDB(GENERIC_CONDUIT_REMOTE_DB, 0, dbHandleRef, eDbWrite | eDbRead | eDbExclusive);
	if(retval != SYNCERR_NONE){
		return retval;
	}

	//Reset rrInfo.
	memset(&rrInfo, 0, sizeof(rrInfo));
	
	//Set rrInfo.
	rrInfo.m_FileHandle	= dbHandle; 
	rrInfo.m_CatId		= 0;						//0: for all.
	rrInfo.m_RecId		= MemoCreatorId; 
	rrInfo.m_pBytes		= (BYTE *)memo; 
	rrInfo.m_RecSize	= MemoMaxLength; 
	rrInfo.m_TotalBytes	= MemoMaxLength; 

	std::fstream cFStrm("c:/MemoSync.txt", std::ios::out );
	//retval = SyncReadNextModifiedRec(rrInfo);
	retval = SyncReadNextRecInCategory(rrInfo);
	while(retval == SYNCERR_NONE){
		cFStrm << memo << std::endl;
		//retval = SyncReadNextModifiedRec(rrInfo);
		retval = SyncReadNextRecInCategory(rrInfo);
	}

	//Close database on handheld.
	SyncCloseDBEx(dbHandle, SYNC_CLOSE_DB_OPT_UPDATE_MOD_DATE);
	
    // Unregister the conduit
    retval = SyncUnRegisterConduit(m_ConduitHandle);
    m_ConduitHandle = 0;

	return retval;
}


/////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////
//
//     Function:        OpenConduit()
//
//     Description:  Entry point into this conduit which starts the
//                 process of synchronizing the local database table with
//                 a remote counterpart residing on the remote view device. 
//
//     Parameters:   Pointer to a callback function used to report progress.
//                    
//                
//
//     Returns:        
//
/////////////////////////////////////////////////////////////////////////////
//     REVISION HISTORY:
//      11/29/2007 IRJB initial 
//
/////////////////////////////////////////////////////////////////////////////
MEMOCONDUIT_API long OpenConduit(PROGRESSFN pFn, CSyncProperties& rProps)
{
	long retval = -1;

	if (pFn)
    {
        CSynchronizer* pGeneric;

        pGeneric = new CSynchronizer();// you will need to make this decision in your code
        if (pGeneric){
            retval = pGeneric->Perform();

            delete pGeneric;
        }

    }
    return(retval);
}

/////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////
//
//       Function:     GetConduitVersion()
//
//       Description:  Entry point into this conduit which returns 
//							the conduits version
//
//       Parameters:   none
//
/////////////////////////////////////////////////////////////////////////////
//       REVISION HISTORY:
//      11/29/2007 IRJB initial 
/////////////////////////////////////////////////////////////////////////////
MEMOCONDUIT_API DWORD GetConduitVersion()
{
    return GENERIC_CONDUIT_VERSION;
}

/////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////
//
//       Function:              GetConduitName()
//
//       Description:  Entry point into this conduit which returns the name 
//							to be used when display messages regarding
//							this conduit.
//
//       Parameters:	pszName - buffer in which to place the name
//                      nLen	- maximum number of bytes of buffer     
//
//       Returns:          -1 indicates errors
//
/////////////////////////////////////////////////////////////////////////////
//       REVISION HISTORY:
//      11/29/2007 IRJB initial 
//
/////////////////////////////////////////////////////////////////////////////
MEMOCONDUIT_API long GetConduitName(char* pszName,WORD nLen)
{
    long retval = 0;

	/*
    if (::LoadString((HINSTANCE)hLangInstance, IDS_CONDUIT_NAME, (LPWSTR)pszName, nLen))
        retval = 0;
	*/

	strncpy_s(pszName, nLen, GENERIC_CONDUIT_NAME, GENERIC_CONDUIT_NAME_LENGTH);

    return retval;
}

